Loading...
Searching...
No Matches
uhd::usrp::dboard_manager Class Referenceabstract

`#include <uhd/usrp/dboard_manager.hpp>`

Inheritance diagram for uhd::usrp::dboard_manager:
[legend]
Collaboration diagram for uhd::usrp::dboard_manager:
[legend]

## Public Types

typedef std::shared_ptr< dboard_manager > | sptr
typedef dboard_base::sptr(* | dboard_ctor_t) (dboard_base::ctor_args_t)

## Public Member Functions

virtual | ~dboard_manager ()
virtual void | initialize_dboards ()=0
virtual const std::vector< std::string > & | get_rx_frontends () const =0
virtual const std::vector< std::string > & | get_tx_frontends () const =0

## Static Public Member Functions

static void | register_dboard (const dboard_id_t &dboard_id, dboard_ctor_t db_subdev_ctor, const std::string &name, const std::vector< std::string > &subdev_names=std::vector< std::string >(1, "0"), dboard_ctor_t db_container_ctor=NULL)
static void | register_dboard (const dboard_id_t &rx_dboard_id, const dboard_id_t &tx_dboard_id, dboard_ctor_t db_subdev_ctor, const std::string &name, const std::vector< std::string > &subdev_names=std::vector< std::string >(1, "0"), dboard_ctor_t db_container_ctor=NULL)
static void | register_dboard_restricted (const dboard_id_t &dboard_id, dboard_ctor_t db_subdev_ctor, const std::string &name, const std::vector< std::string > &subdev_names=std::vector< std::string >(1, "0"), dboard_ctor_t db_container_ctor=NULL)
static void | register_dboard_restricted (const dboard_id_t &rx_dboard_id, const dboard_id_t &tx_dboard_id, dboard_ctor_t db_subdev_ctor, const std::string &name, const std::vector< std::string > &subdev_names=std::vector< std::string >(1, "0"), dboard_ctor_t db_container_ctor=NULL)
static sptr | make (dboard_id_t rx_dboard_id, dboard_id_t tx_dboard_id, dboard_id_t gdboard_id, dboard_iface::sptr iface, property_tree::sptr subtree, bool defer_db_init=false)
static sptr | make (dboard_eeprom_t rx_eeprom, dboard_eeprom_t tx_eeprom, dboard_eeprom_t gdb_eeprom, dboard_iface::sptr iface, property_tree::sptr subtree, bool defer_db_init=false)

## Detailed Description

A daughter board subdev dboard_manager class. Create subdev instances for each subdev on a dboard. Provide wax::obj access to the subdevs inside.

## Member Typedef Documentation

## dboard_ctor_t

typedef dboard_base::sptr(* uhd::usrp::dboard_manager::dboard_ctor_t) (dboard_base::ctor_args_t)

## sptr

typedef std::shared_ptr<dboard_manager> uhd::usrp::dboard_manager::sptr

## Constructor & Destructor Documentation

## ~dboard_manager()

virtual uhd::usrp::dboard_manager::~dboard_manager | ( |  | ) |

inline virtual

## Member Function Documentation

## get_rx_frontends()

virtual const std::vector< std::string > & uhd::usrp::dboard_manager::get_rx_frontends | ( |  | ) | const

pure virtual

Returns a vector of RX frontend (subdev) names

Returns
  a vector of names

## get_tx_frontends()

virtual const std::vector< std::string > & uhd::usrp::dboard_manager::get_tx_frontends | ( |  | ) | const

pure virtual

Returns a vector of TX frontend (subdev) names

Returns
  a vector of names

## initialize_dboards()

virtual void uhd::usrp::dboard_manager::initialize_dboards | ( |  | ) |

pure virtual

Run dboard post constructor initializations if defered during make

## make() [1/2]

sptr uhd::usrp::dboard_manager::make | ( | dboard_eeprom_t | rx_eeprom,
|  | dboard_eeprom_t | tx_eeprom,
|  | dboard_eeprom_t | gdb_eeprom,
|  | dboard_iface::sptr | iface,
|  | property_tree::sptr | subtree,
|  | bool | defer_db_init = false )

static

Make a new dboard manager.

Parameters

  rx_eeprom | the RX EEPROM data
  tx_eeprom | the TX EEPROM data
  gdb_eeprom | the grand-dboard EEPROM data
  iface | the custom dboard interface
  subtree | the subtree to load with props
  defer_db_init | initialising the daughterboards (DEPRECATED)

Returns
  an sptr to the new dboard manager

## make() [2/2]

sptr uhd::usrp::dboard_manager::make | ( | dboard_id_t | rx_dboard_id,
|  | dboard_id_t | tx_dboard_id,
|  | dboard_id_t | gdboard_id,
|  | dboard_iface::sptr | iface,
|  | property_tree::sptr | subtree,
|  | bool | defer_db_init = false )

static

Make a new dboard manager.

Parameters

  rx_dboard_id | the id of the rx dboard
  tx_dboard_id | the id of the tx dboard
  gdboard_id | the id of the grand-dboard
  iface | the custom dboard interface
  subtree | the subtree to load with props
  defer_db_init | initialising the daughterboards (DEPRECATED)

Returns
  an sptr to the new dboard manager

## register_dboard() [1/2]

void uhd::usrp::dboard_manager::register_dboard | ( | const dboard_id_t & | dboard_id,
|  | dboard_ctor_t | db_subdev_ctor,
|  | const std::string & | name,
|  | const std::vector< std::string > & | subdev_names = std::vector< std::string >(1, "0"),
|  | dboard_ctor_t | db_container_ctor = NULL )

static

Register a rx or tx dboard into the system. For single subdevice boards, omit subdev_names.

Parameters

  dboard_id | the dboard id (rx or tx)
  db_subdev_ctor | the dboard sub-device constructor function pointer (one instance per subdev name)
  name | the canonical name for the dboard represented
  subdev_names | the names of the subdevs on this dboard
  db_container_ctor | the dboard container constructor function pointer (one instance per dboard)

## register_dboard() [2/2]

void uhd::usrp::dboard_manager::register_dboard | ( | const dboard_id_t & | rx_dboard_id,
|  | const dboard_id_t & | tx_dboard_id,
|  | dboard_ctor_t | db_subdev_ctor,
|  | const std::string & | name,
|  | const std::vector< std::string > & | subdev_names = std::vector< std::string >(1, "0"),
|  | dboard_ctor_t | db_container_ctor = NULL )

static

Register an xcvr dboard into the system. For single subdevice boards, omit subdev_names.

Parameters

  rx_dboard_id | the rx unit dboard id
  tx_dboard_id | the tx unit dboard id
  db_subdev_ctor | the dboard sub-device constructor function pointer (one instance per subdev name)
  name | the canonical name for the dboard represented
  subdev_names | the names of the subdevs on this dboard
  db_container_ctor | the dboard container constructor function pointer (one instance per dboard)

## register_dboard_restricted() [1/2]

void uhd::usrp::dboard_manager::register_dboard_restricted | ( | const dboard_id_t & | dboard_id,
|  | dboard_ctor_t | db_subdev_ctor,
|  | const std::string & | name,
|  | const std::vector< std::string > & | subdev_names = std::vector< std::string >(1, "0"),
|  | dboard_ctor_t | db_container_ctor = NULL )

static

Register a restricted rx or tx dboard into the system. A restricted dboard does not add its dboard_iface object into the property tree. For single subdevice boards, omit subdev_names. The iface for a restricted board is not registered into the property tree.

Parameters

  dboard_id | the dboard id (rx or tx)
  db_subdev_ctor | the dboard sub-device constructor function pointer (one instance per subdev name)
  name | the canonical name for the dboard represented
  subdev_names | the names of the subdevs on this dboard
  db_container_ctor | the dboard container constructor function pointer (one instance per dboard)

## register_dboard_restricted() [2/2]

void uhd::usrp::dboard_manager::register_dboard_restricted | ( | const dboard_id_t & | rx_dboard_id,
|  | const dboard_id_t & | tx_dboard_id,
|  | dboard_ctor_t | db_subdev_ctor,
|  | const std::string & | name,
|  | const std::vector< std::string > & | subdev_names = std::vector< std::string >(1, "0"),
|  | dboard_ctor_t | db_container_ctor = NULL )

static

Register a restricted xcvr dboard into the system. A restricted dboard does not add its dboard_iface object into the property tree. For single subdevice boards, omit subdev_names. The iface for a restricted board is not registered into the property tree.

Parameters

  rx_dboard_id | the rx unit dboard id
  tx_dboard_id | the tx unit dboard id
  db_subdev_ctor | the dboard sub-device constructor function pointer (one instance per subdev name)
  name | the canonical name for the dboard represented
  subdev_names | the names of the subdevs on this dboard
  db_container_ctor | the dboard container constructor function pointer (one instance per dboard)

The documentation for this class was generated from the following file:

- dboard_manager.hpp